]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

cleanups
[code/myrepos.git] / mr
diff --git a/mr b/mr
index 3162623b0e86263a93b044f2d2adc198fae222a9..65b0b1d3b4c5e3495590616d113b3a81a8091f4d 100755 (executable)
--- a/mr
+++ b/mr
@@ -22,24 +22,24 @@ B<mr> [options] log
 
 B<mr> [options] register [repository]
 
-B<mr> [options] config section [parameter=[value] ...]
+B<mr> [options] config section ["parameter=[value]" ...]
 
 B<mr> [options] action [params ...]
 
 =head1 DESCRIPTION
 
-B<mr> is a Multiple Repository management tool. It
-can checkout, update, or perform other actions on
-a set of repositories as if they were one combined respository. It
-supports any combination of subversion, git, cvs, and bzr repositories, 
-and support for other revision control systems can easily be added.
+B<mr> is a Multiple Repository management tool. It can checkout, update, or
+perform other actions on a set of repositories as if they were one combined
+respository. It supports any combination of subversion, git, cvs, mecurial and
+bzr repositories, and support for other revision control systems can easily be
+added.
 
-B<mr> cds into and operates on all registered repsitories at or below your
+B<mr> cds into and operates on all registered repositories at or below your
 working directory. Or, if you are in a subdirectory of a repository that
 contains no other registered repositories, it will stay in that directory,
 and work on only that repository,
 
-The predefined commands should be fairly familiar to users of any revision
+These predefined commands should be fairly familiar to users of any revision
 control system:
 
 =over 4
@@ -74,19 +74,28 @@ Show a diff of uncommitted changes.
 
 Show the commit log.
 
+=back
+
+These commands are also available:
+
+=over 4
+
 =item list (or ls)
 
 List the repositories that mr will act on.
 
 =item register
 
-Register an existing repository in the mrconfig file. By default, the
-epository in the current directory is registered, or you can specify a
+Register an existing repository in a mrconfig file. By default, the
+repository in the current directory is registered, or you can specify a
 directory to register.
 
+The mrconfig file that is modified is chosen by either the -c option, or by
+looking for the closest known one at or below the current directory.
+
 =item config
 
-Adds, modifies, removes, or prints a value from the mrconfig file. The next
+Adds, modifies, removes, or prints a value from a mrconfig file. The next
 parameter is the name of the section the value is in. To add or modify
 values, use one or more instances of "parameter=value". Use "parameter=" to
 remove a parameter. Use just "parameter" to get the value of a parameter.
@@ -99,6 +108,13 @@ To show the command that mr uses to update the repository in src/foo:
 
   mr config src/foo update
 
+To see the built-in library of shell functions contained in mr:
+
+  mr config DEFAULT lib
+
+The ~/.mrconfig file is used by default. To use a different config file,
+use the -c option.
+
 =item help
 
 Displays this help.
@@ -125,13 +141,22 @@ the current working directory.
 
 =item -c mrconfig
 
-Use the specified mrconfig file, instead of looking for one in your home
-directory.
+Use the specified mrconfig file. The default is B<~/.mrconfig>
 
 =item -v
 
 Be verbose.
 
+=item -s
+
+Expand the statistics line displayed at the end to include information
+about exactly which repositories failed and were skipped, if any.
+
+=item -n
+
+Just operate on the repository for the current directory, do not 
+recurse into deeper repositories.
+
 =back
 
 =head1 FILES
@@ -167,17 +192,20 @@ that contains the mrconfig file, but you can also choose to use absolute
 paths.
 
 Within a section, each parameter defines a shell command to run to handle a
-given action. mr contains default handlers for the "update", "status", and
-"commit" actions, so normally you only need to specify what to do for
-"checkout".
+given action. mr contains default handlers for "update", "status",
+"commit", and other standard actions. Normally you only need to specify what
+to do for "checkout".
 
 Note that these shell commands are run in a "set -e" shell
 environment, where any additional parameters you pass are available in
 "$@". The "checkout" command is run in the parent of the repository
 directory, since the repository isn't checked out yet. All other commands
 are run inside the repository, though not necessarily at the top of it.
+
 The "MR_REPO" environment variable is set to the path to the top of the
-repository.
+repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
+that defines the repo being acted on, or, if the repo is not yet in a config
+file, the .mrconfig file that should be modified to register the repo.
 
 A few parameters have special meanings:
 
@@ -185,7 +213,7 @@ A few parameters have special meanings:
 
 =item skip
 
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
 will skip acting on that repository. The command is passed the action
 name in $1.
 
@@ -199,18 +227,10 @@ been at least 12 hours since the last update.
 
 =item chain
 
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
 will try to load a .mrconfig file from the root of the repository. (You
 should avoid chaining from repositories with untrusted committers.)
 
-=item deleted
-
-If the "deleted" parameter is set and its command returns nonzero, then
-B<mr> will treat the repository as deleted. It won't ever actually delete
-the repository, but it will warn if it sees the repsoitory's directory.
-This is useful when one mrconfig file is shared amoung multiple machines,
-to keep track of and remember to delete old repositories.
-
 =item lib
 
 The "lib" parameter can specify some shell code that will be run before each
@@ -236,18 +256,29 @@ use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
 
+$SIG{INT}=sub {
+       print STDERR "mr: interrupted\n";
+       exit 2;
+};
+
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+my $config_overridden=0;
 my $directory=getcwd();
-my $config="$ENV{HOME}/.mrconfig";
 my $verbose=0;
+my $stats=0;
+my $no_recurse=0;
 my %config;
+my %configfiles;
 my %knownactions;
 my %alias;
 
 Getopt::Long::Configure("no_permute");
 my $result=GetOptions(
        "d|directory=s" => sub { $directory=abs_path($_[1]) },
-       "c|config=s" => \$config,
-       "verbose" => \$verbose,
+       "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
+       "v|verbose" => \$verbose,
+       "s|stats" => \$stats,
+       "n|no-recurse" => \$no_recurse,
 );
 if (! $result || @ARGV < 1) {
        die("Usage: mr [-d directory] action [params ...]\n".
@@ -255,8 +286,15 @@ if (! $result || @ARGV < 1) {
 
 }
 
+# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+# the config file might be a symlink to elsewhere, and the directory it's
+# in is significant.
+if ($ENV{MR_CONFIG} !~ /^\//) {
+       $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+}
+
 loadconfig(\*DATA);
-loadconfig($config);
+loadconfig($ENV{MR_CONFIG});
 #use Data::Dumper;
 #print Dumper(\%config);
 
@@ -286,6 +324,7 @@ if (! exists $knownactions{$action}) {
        }
 }
 
+# commands that do not operate on all repos
 if ($action eq 'help') {
        exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
 }
@@ -295,8 +334,10 @@ elsif ($action eq 'config') {
        }
        my $section=shift;
        if ($section=~/^\//) {
-               # try to convert to a path relative to $config's dir
-               my ($dir)=$config=~/^(.*\/)[^\/]+$/;
+               # try to convert to a path relative to the config file
+               my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
+               $dir=abs_path($dir);
+               $dir.="/" unless $dir=~/\/$/;
                if ($section=~/^\Q$dir\E(.*)/) {
                        $section=$1;
                }
@@ -313,6 +354,7 @@ elsif ($action eq 'config') {
                                    exists $config{$topdir}{$section}{$_}) {
                                        print $config{$topdir}{$section}{$_}."\n";
                                        $found=1;
+                                       last if $section eq 'DEFAULT';
                                }
                        }
                        if (! $found) {
@@ -320,10 +362,22 @@ elsif ($action eq 'config') {
                        }
                }
        }
-       modifyconfig($config, $section, %changefields) if %changefields;
+       modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
        exit 0;
 }
 elsif ($action eq 'register') {
+       if (! $config_overridden) {
+               # Find the closest known mrconfig file to the current
+               # directory.
+               $directory.="/" unless $directory=~/\/$/;
+               foreach my $topdir (reverse sort keys %config) {
+                       next unless length $topdir;
+                       if ($directory=~/^\Q$topdir\E/) {
+                               $ENV{MR_CONFIG}=$configfiles{$topdir};
+                               last;
+                       }
+               }
+       }
        my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
                "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
                join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
@@ -341,7 +395,8 @@ foreach my $topdir (sort keys %config) {
                my $d=$directory;
                $dir.="/" unless $dir=~/\/$/;
                $d.="/" unless $d=~/\/$/;
-               next if $dir ne $directory && $dir !~ /^\Q$directory\E/;
+               next if $no_recurse && $d ne $dir;
+               next if $dir ne $d && $dir !~ /^\Q$d\E/;
                push @repos, [$dir, $topdir, $subdir];
        }
 }
@@ -370,25 +425,10 @@ foreach my $repo (@repos) {
 
 sub action { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
-       
-       my $lib= exists $config{$topdir}{$subdir}{lib} ?
-                       $config{$topdir}{$subdir}{lib}."\n" : "";
 
-       if (exists $config{$topdir}{$subdir}{deleted}) {
-               if (! -d $dir) {
-                       return;
-               }
-               else {
-                       my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
-                       print "mr $action: running deleted test >>$test<<\n" if $verbose;
-                       my $ret=system($test);
-                       if ($ret >> 8 == 0) {
-                               print STDERR "mr error: $dir should be deleted yet still exists\n\n";
-                               push @failed, $dir;
-                               return;
-                       }
-               }
-       }
+       $ENV{MR_CONFIG}=$configfiles{$topdir};
+       my $lib=exists $config{$topdir}{$subdir}{lib} ?
+                      $config{$topdir}{$subdir}{lib}."\n" : "";
 
        if ($action eq 'checkout') {
                if (-d $dir) {
@@ -396,7 +436,13 @@ sub action { #{{{
                        push @skipped, $dir;
                        return;
                }
+
                $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
+
+               if (! -d $dir) {
+                       print "mr $action: creating parent directory $dir\n" if $verbose;
+                       my $ret=system("mkdir", "-p", $dir);
+               }
        }
        elsif ($action eq 'update') {
                if (! -d $dir) {
@@ -411,6 +457,16 @@ sub action { #{{{
                        "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
                print "mr $action: running skip test >>$test<<\n" if $verbose;
                my $ret=system($test);
+               if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               exit 2;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
+                               exit 1;
+                       }
+               }
                if ($ret >> 8 == 0) {
                        print "mr $action: $dir skipped per config file\n" if $verbose;
                        push @skipped, $dir;
@@ -439,6 +495,13 @@ sub action { #{{{
                print STDERR "mr $action: running >>$command<<\n" if $verbose;
                my $ret=system($command);
                if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               exit 2;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: received signal ".($? & 127)."\n";
+                       }
                        print STDERR "mr $action: failed ($ret)\n" if $verbose;
                        push @failed, $dir;
                        if ($ret >> 8 != 0) {
@@ -449,6 +512,12 @@ sub action { #{{{
                        }
                }
                else {
+                       if ($action eq 'checkout' && ! -d $dir) {
+                               print STDERR "mr $action: $dir missing after checkout\n";;
+                               push @failed, $dir;
+                               return;
+                       }
+
                        push @ok, $dir;
                }
 
@@ -473,6 +542,14 @@ print "mr $action: finished (".join("; ",
        showstat($#failed+1, "failed", "failed"),
        showstat($#skipped+1, "skipped", "skipped"),
 ).")\n";
+if ($stats) {
+       if (@skipped) {
+               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+       }
+       if (@failed) {
+               print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
+       }
+}
 if (@failed) {
        exit 1;
 }
@@ -509,10 +586,17 @@ sub loadconfig { #{{{
                        $dir=".";
                }
                $dir=abs_path($dir)."/";
+               
+               if (! exists $configfiles{$dir}) {
+                       $configfiles{$dir}=$f;
+               }
 
                # copy in defaults from first parent
                my $parent=$dir;
-               while ($parent=~s/^(.*)\/[^\/]+\/?$/$1/) {
+               while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
+                       if ($parent eq '/') {
+                               $parent="";
+                       }
                        if (exists $config{$parent} &&
                            exists $config{$parent}{DEFAULT}) {
                                $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
@@ -568,9 +652,20 @@ sub loadconfig { #{{{
                                $knownactions{$parameter}=1;
                                if ($parameter eq 'chain' &&
                                    length $dir && $section ne "DEFAULT" &&
-                                   -e $dir.$section."/.mrconfig" &&
-                                   system($value) >> 8 == 0) {
-                                       push @toload, $dir.$section."/.mrconfig";
+                                   -e $dir.$section."/.mrconfig") {
+                                       my $ret=system($value);
+                                       if ($ret != 0) {
+                                               if (($? & 127) == 2) {
+                                                       print STDERR "mr $action: chain test interrupted\n";
+                                                       exit 2;
+                                               }
+                                               elsif ($? & 127) {
+                                                       print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+                                               }
+                                       }
+                                       else {
+                                               push @toload, $dir.$section."/.mrconfig";
+                                       }
                                }
                        }
                }
@@ -697,7 +792,7 @@ lib =
                exit 1
        }
        hours_since() {
-               for dir in .git .svn .bzr CVS; do
+               for dir in .git .svn .bzr CVS .hg; do
                        if [ -e "$MR_REPO/$dir" ]; then
                                flagfile="$MR_REPO/$dir/.mr_last$1"
                                break
@@ -714,11 +809,17 @@ update =
        if [ -d "$MR_REPO"/.svn ]; then
                svn update "$@"
        elif [ -d "$MR_REPO"/.git ]; then
-               git pull origin master "$@"
+               if [ -z "$@" ]; then
+                       git pull -t origin master
+               else
+                       git pull "$@"
+               fi
        elif [ -d "$MR_REPO"/.bzr ]; then
                bzr merge "$@"
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs update "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg pull "$@" && hg update "$@"
        else
                error "unknown repo type"
        fi
@@ -731,6 +832,8 @@ status =
                bzr status "$@"
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs status "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg status "$@"
        else
                error "unknown repo type"
        fi
@@ -743,6 +846,8 @@ commit =
                bzr commit "$@" && bzr push
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs commit "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg commit -m "$@" && hg push
        else
                error "unknown repo type"
        fi
@@ -755,6 +860,8 @@ diff =
                bzr diff "$@"
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs diff "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg diff "$@"
        else
                error "unknown repo type"
        fi
@@ -767,6 +874,8 @@ log =
                bzr log "$@"
        elif [ -d "$MR_REPO"/CVS ]; then
                cvs log "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg log "$@"
        else
                error "unknown repo type"
        fi
@@ -780,22 +889,36 @@ register =
                if [ -z "$url" ]; then
                        error "cannot determine svn url"
                fi
-               echo "Registering svn url: $url"
-               mr config "$(pwd)" checkout="svn co $url $basedir"
+               echo "Registering svn url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
        elif [ -d .git ]; then
                url=$(LANG=C git-config --get remote.origin.url)
                if [ -z "$url" ]; then
                        error "cannot determine git url"
                fi
-               echo "Registering git url: $url"
-               mr config "$(pwd)" checkout="git clone $url $basedir"
+               echo "Registering git url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
        elif [ -d .bzr ]; then
                url=$(cat .bzr/branch/parent)
                if [ -z "$url" ]; then
                        error "cannot determine bzr url"
                fi
-               echo "Registering bzr url: $url"
-               mr config "$(pwd)" checkout="bzr clone $url $basedir"
+               echo "Registering bzr url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
+       elif [ -d CVS ]; then
+               repo=$(cat CVS/Repository)
+               root=$(cat CVS/Root)
+               if [ -z "$root" ]; then
+                       error "cannot determine cvs root"
+               fi
+               echo "Registering cvs repository $repo at root $root"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="cvs -d '$root' co -d $basedir $repo"
+       elif [ -d .hg ]; then
+               url=$(hg showconfig paths.default)
+               echo "Registering mercurial repo url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="hg clone $url $basedir"
        else
                error "unable to register this repo type"
        fi